/// <reference types="node" />
import * as net from "net";
import EventEmitter from "events";
import Command, { RedisResponse } from "./command";
import RedisParser from "./parser";
export interface RedisOpts {
    db?: number;
    passwd?: string;
    autoConnect: boolean;
    host: string;
    port: number;
}
declare class RedisBase extends EventEmitter {
    options: RedisOpts;
    protected client?: net.Socket;
    protected commandQuene: Command[];
    protected parser: RedisParser;
    protected listening: boolean;
    constructor(options?: RedisOpts);
    protected send(name: string, ...params: any[]): Promise<RedisResponse>;
    protected onDataHanlder: (data: Buffer) => void;
    protected onErrorHanlder(e: Error): void;
    disconnect(): void;
    connect(): RedisBase;
    sendCommand(name: string, ...params: any[]): Promise<any>;
    subscribe(channel: string): Promise<RedisResponse>;
    psubscribe(channel: string): Promise<RedisResponse>;
    unpsubscribe(channel: string): Promise<void>;
    unsubscribe(channel: string): Promise<void>;
}
export default RedisBase;
