"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var net = __importStar(require("net"));
var events_1 = __importDefault(require("events"));
var command_1 = __importStar(require("./command"));
var parser_1 = __importDefault(require("./parser"));
var RedisBase = /** @class */ (function (_super) {
    __extends(RedisBase, _super);
    function RedisBase(options) {
        if (options === void 0) { options = { port: 6379, host: "127.0.0.1", autoConnect: true }; }
        var _this = _super.call(this) || this;
        _this.listening = false;
        _this.onDataHanlder = function (data) {
            _this.parser.parse(data.toString());
        };
        _this.options = options;
        _this.commandQuene = [];
        if (options.autoConnect) {
            _this.connect();
        }
        _this.parser = new parser_1.default({
            onParseArray: function (dataArr) {
                if (_this.commandQuene.length == 0 && _this.listening) {
                    if (dataArr[0] == "message") {
                        _this.emit(dataArr[1], dataArr[2]);
                    }
                }
                else {
                    var command = _this.commandQuene[0];
                    if (command) {
                        command.setArr(dataArr);
                        _this.commandQuene.shift();
                    }
                }
            },
            onParseErrors: function (error) {
                var command = _this.commandQuene[0];
                if (command) {
                    command.setErrMsg(error);
                    _this.commandQuene.shift();
                }
            },
            onParseBulkSrings: function (bulkString) {
                var command = _this.commandQuene[0];
                if (command) {
                    command.setBulkMsg(bulkString);
                    _this.commandQuene.shift();
                }
            },
            onParseIntegers: function (interger) {
                var command = _this.commandQuene[0];
                if (command) {
                    command.setIntMsg(interger);
                    _this.commandQuene.shift();
                }
            },
            onParseStrings: function (data) {
                var command = _this.commandQuene[0];
                if (command) {
                    command.setStrMsg(data);
                    _this.commandQuene.shift();
                }
            }
        });
        return _this;
    }
    RedisBase.prototype.send = function (name) {
        var _this = this;
        var params = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            params[_i - 1] = arguments[_i];
        }
        if (!this.client) {
            throw new Error("The connnection has not been established yet.");
        }
        var m = new (command_1.default.bind.apply(command_1.default, [void 0, name].concat(params)))();
        this.client.write(m.toString(), function (e) {
            if (e) {
                return;
            }
            _this.commandQuene.push(m);
        });
        return m.asPromise();
    };
    RedisBase.prototype.onErrorHanlder = function (e) {
        console.error("redis client got error message " + e.message);
    };
    RedisBase.prototype.disconnect = function () {
        if (this.client) {
            this.client.end();
        }
    };
    RedisBase.prototype.connect = function () {
        var _this = this;
        if (this.client) {
            return this;
        }
        var options = this.options;
        this.client = net.connect(options.port, options.host, function () {
            if (options.passwd) {
                _this.send("AUTH", options.passwd);
            }
            if (options.db) {
                _this.send("SELECT", options.db);
            }
        });
        this.client.on("data", this.onDataHanlder);
        this.client.on("error", this.onErrorHanlder);
        return this;
    };
    RedisBase.prototype.sendCommand = function (name) {
        var params = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            params[_i - 1] = arguments[_i];
        }
        return __awaiter(this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.listening) {
                            return [2 /*return*/, Promise.reject(new Error("instance has been blocked then cannot send message"))];
                        }
                        return [4 /*yield*/, this.send.apply(this, [name].concat(params))];
                    case 1:
                        result = _a.sent();
                        return [2 /*return*/, result.toValue()];
                }
            });
        });
    };
    RedisBase.prototype.subscribe = function (channel) {
        this.listening = true;
        return this.send("SUBSCRIBE", channel);
    };
    RedisBase.prototype.psubscribe = function (channel) {
        this.listening = true;
        return this.send("PSUBSCRIBE", channel);
    };
    RedisBase.prototype.unpsubscribe = function (channel) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, type, arrMsg;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.send("PUNSUBSCRIBE", channel)];
                    case 1:
                        _a = _b.sent(), type = _a.type, arrMsg = _a.arrMsg;
                        if (type == command_1.RedisType.Array && arrMsg && arrMsg[2] && +arrMsg[2] == 0) {
                            this.listening = false;
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    RedisBase.prototype.unsubscribe = function (channel) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, type, arrMsg;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.send("UNSUBSCRIBE", channel)];
                    case 1:
                        _a = _b.sent(), type = _a.type, arrMsg = _a.arrMsg;
                        if (type == command_1.RedisType.Array && arrMsg && arrMsg[2] && +arrMsg[2] == 0) {
                            this.listening = false;
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    return RedisBase;
}(events_1.default));
exports.default = RedisBase;
