/// <reference types="node" />
import EventEmitter from "events";
export declare enum RedisType {
    Integers = 0,
    Errors = 1,
    Strings = 2,
    BulkSrings = 3,
    Array = 4
}
export declare class RedisResponse {
    type: RedisType;
    intMsg?: number;
    errMsg?: string;
    strMsg?: string;
    bulkMsg?: string;
    arrMsg?: string[];
    constructor(options: {
        type: RedisType;
        intMsg?: number;
        errMsg?: string;
        strMsg?: string;
        bulkMsg?: string;
        arrMsg?: string[];
    });
    toValue(): string | number | string[] | undefined;
}
declare class RedisCommand extends EventEmitter {
    private name;
    private params;
    private res?;
    private resolved;
    constructor(name: string, ...params: any[]);
    asPromise(): Promise<RedisResponse>;
    setIntMsg(integer: number): void;
    setErrMsg(errMsg: string): void;
    setStrMsg(strMsg: string): void;
    setBulkMsg(bulkMsg: string): void;
    setArr(arr: string[]): void;
    toString(): string;
}
export declare function createCommand(name: string, ...params: string[]): RedisCommand;
export default RedisCommand;
